﻿Imports System.Reflection
Imports System.Diagnostics

Module Module1

    Sub Main()
        Test1()
        Test2()

        Console.ReadLine()
    End Sub

    Sub Test1()
        Console.WriteLine("Test1 wurde aufgerufen von " & _
            Module1.GetCallingMethod().Name)
        Test2()
    End Sub

    Sub Test2()
        Console.WriteLine("Test2 wurde aufgerufen von " & _
            Module1.GetCallingMethod().Name)
    End Sub

    ''' <summary>
    ''' Gibt die Methode zurück, die die gerade ausgeführte Methode aufgerufen 
    '''  hat.
    ''' </summary>
    ''' <param name="index"> 
    '''  Gibt an, der wievielte Aufrufer zurückgegeben werden soll.
    ''' </param>
    ''' <returns>Ein Objekt vom Typ System.Reflection.MethodBase.</returns>
    Public Function GetCallingMethod( _
        Optional ByVal index As Integer = 0) As MethodBase

        Dim stackTrace As New StackTrace()

        If index < 0 Then Throw New ArgumentException( _
            "Index must not be a negative number.", "index")
        If stackTrace.GetFrames().Count <= 2 + index Then _
            Throw New Exception("There aren't that much method calls.")

        Return stackTrace.GetFrame(2 + index).GetMethod()
    End Function

End Module
